<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>polylib: matrix_permutations.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.6.1 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="main.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.html"><span>File&nbsp;Members</span></a></li>
    </ul>
  </div>
<h1>matrix_permutations.h</h1><a href="matrix__permutations_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    This file is part of PolyLib.</span>
<a name="l00003"></a>00003 <span class="comment"></span>
<a name="l00004"></a>00004 <span class="comment">    PolyLib is free software: you can redistribute it and/or modify</span>
<a name="l00005"></a>00005 <span class="comment">    it under the terms of the GNU General Public License as published by</span>
<a name="l00006"></a>00006 <span class="comment">    the Free Software Foundation, either version 3 of the License, or</span>
<a name="l00007"></a>00007 <span class="comment">    (at your option) any later version.</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">    PolyLib is distributed in the hope that it will be useful,</span>
<a name="l00010"></a>00010 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00011"></a>00011 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</span>
<a name="l00012"></a>00012 <span class="comment">    GNU General Public License for more details.</span>
<a name="l00013"></a>00013 <span class="comment"></span>
<a name="l00014"></a>00014 <span class="comment">    You should have received a copy of the GNU General Public License</span>
<a name="l00015"></a>00015 <span class="comment">    along with PolyLib.  If not, see &lt;http://www.gnu.org/licenses/&gt;.</span>
<a name="l00016"></a>00016 <span class="comment">*/</span>
<a name="l00017"></a>00017 <span class="comment"></span>
<a name="l00018"></a>00018 <span class="comment">/**</span>
<a name="l00019"></a>00019 <span class="comment"> * Permutations on matrices</span>
<a name="l00020"></a>00020 <span class="comment"> * Matrices are seen either as transformations (mtransformation) or as</span>
<a name="l00021"></a>00021 <span class="comment"> * polyhedra (mpolyhedron or Constraints).</span>
<a name="l00022"></a>00022 <span class="comment"> * @author B. Meister</span>
<a name="l00023"></a>00023 <span class="comment"> */</span>
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 <span class="preprocessor">#ifndef __BM_MATRIX_PERMUTATIONS_H__</span>
<a name="l00026"></a>00026 <span class="preprocessor"></span><span class="preprocessor">#define __BM_MATRIX_PERMUTATIONS_H__</span>
<a name="l00027"></a>00027 <span class="preprocessor"></span>
<a name="l00028"></a>00028 <span class="preprocessor">#include&lt;<a class="code" href="polylib_8h.html">polylib/polylib.h</a>&gt;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include&lt;<a class="code" href="assert_8h.html">assert.h</a>&gt;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="comment">/* Permutations here are vectors that give the future position for each</span>
<a name="l00032"></a>00032 <span class="comment">   variable */</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="comment">/* utility function : bit count */</span>
<a name="l00035"></a>00035 <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="matrix__permutations_8c.html#a9258ae89e8c6c38ba0a82824cd790fef" title="Idmatrix_permutations.c,v 1.8 2006/10/01 02:10:46 meister Exp ">nb_bits</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> <span class="keywordtype">long</span> <span class="keywordtype">int</span> x);
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="comment">/* gives the inverse permutation vector of a permutation vector */</span>
<a name="l00038"></a>00038 <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> * <a class="code" href="matrix__permutations_8c.html#afbe2c7462b899ca85c30140ac5403089" title="Gives the inverse permutation vector of a permutation vector.">permutation_inverse</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> * perm, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nb_elems);
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 <span class="comment">/*</span>
<a name="l00041"></a>00041 <span class="comment"> * Given a linear tranformation on initial variables, and a variable</span>
<a name="l00042"></a>00042 <span class="comment"> * permutation, compute the tranformation for the permuted variables.  perm is</span>
<a name="l00043"></a>00043 <span class="comment"> * a vector giving the new &quot;position of the k^th variable, k \in [1..n] we can</span>
<a name="l00044"></a>00044 <span class="comment"> * call it a &quot;permutation vector&quot; if you wish transf[x][y] -&gt;</span>
<a name="l00045"></a>00045 <span class="comment"> * permuted[permutation(x)][permutation(y)]</span>
<a name="l00046"></a>00046 <span class="comment"> */</span>
<a name="l00047"></a>00047 <a class="code" href="structmatrix.html">Matrix</a> * <a class="code" href="matrix__permutations_8c.html#ace85f1b44be83dc08923e3a7bc66804c" title="Given a linear tranformation on initial variables, and a variable permutation, computes...">mtransformation_permute</a>(<a class="code" href="structmatrix.html">Matrix</a> * transf, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> * permutation);
<a name="l00048"></a>00048 
<a name="l00049"></a>00049 <span class="comment">/* permutes the variables of a matrix seen as a polyhedron */</span>
<a name="l00050"></a>00050 <a class="code" href="structmatrix.html">Matrix</a> * <a class="code" href="matrix__permutations_8c.html#ae642907b1f7aac2f4ec8f174b27ab830" title="permutes the variables of the constraints of a polyhedron">mpolyhedron_permute</a>(<a class="code" href="structmatrix.html">Matrix</a> * polyh, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> * permutation);
<a name="l00051"></a>00051 
<a name="l00052"></a>00052 <span class="comment">/* permutes the variables of a matrix seen as a polyhedron */</span>
<a name="l00053"></a>00053 <span class="keywordtype">void</span> <a class="code" href="matrix__permutations_8c.html#a1714c230c3b1785a1da3c38bcbf7e661" title="permutes the variables of the constraints of a polyhedron">Constraints_permute</a>(<a class="code" href="structmatrix.html">Matrix</a> * C, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> * perm, <a class="code" href="structmatrix.html">Matrix</a> ** Cp);
<a name="l00054"></a>00054 <span class="comment"></span>
<a name="l00055"></a>00055 <span class="comment">/** Given a set of &lt;i&gt;equalities&lt;/i&gt;, find a set of variables that can be</span>
<a name="l00056"></a>00056 <span class="comment"> * eliminated using these equalities.  The variables that we agree to eliminate</span>
<a name="l00057"></a>00057 <span class="comment"> * are in a zone of contiguous variables (or parameters).  &lt;p&gt;</span>
<a name="l00058"></a>00058 <span class="comment"> * Notes: </span>
<a name="l00059"></a>00059 <span class="comment"> &lt;ul&gt;</span>
<a name="l00060"></a>00060 <span class="comment"> &lt;li&gt;brute force, surely enhanceable algorithm&lt;/li&gt;</span>
<a name="l00061"></a>00061 <span class="comment"> &lt;li&gt;limited number of variables in the zone: limit = bitwidth of long long</span>
<a name="l00062"></a>00062 <span class="comment"> &lt;/ul&gt;</span>
<a name="l00063"></a>00063 <span class="comment"> * @param Eqs the matrix of equalities.</span>
<a name="l00064"></a>00064 <span class="comment"> * @param start the rank of the first variable (inclusive) of the zone in Eqs</span>
<a name="l00065"></a>00065 <span class="comment"> * @param end the rank of the last variable (inclusive) of the zone</span>
<a name="l00066"></a>00066 <span class="comment"> * return a bitfield where bits set to one define the variables to eliminate</span>
<a name="l00067"></a>00067 <span class="comment">*/</span>
<a name="l00068"></a>00068 <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> <span class="keywordtype">long</span> <span class="keywordtype">int</span> <a class="code" href="matrix__permutations_8c.html#a46efd59d133aa22046bd57718c7be05a" title="Given a set of equalities, find a set of variables that can be eliminated using these...">eliminable_vars</a>(<a class="code" href="structmatrix.html">Matrix</a> * Eqs, <span class="keywordtype">unsigned</span> start, 
<a name="l00069"></a>00069                                        <span class="keywordtype">unsigned</span> end);
<a name="l00070"></a>00070 
<a name="l00071"></a>00071 <span class="comment">/*</span>
<a name="l00072"></a>00072 <span class="comment">* find a valid permutation : for a set of m equations, find m variables that</span>
<a name="l00073"></a>00073 <span class="comment">* will be put at the beginning (to be eliminated) it must be possible to</span>
<a name="l00074"></a>00074 <span class="comment">* eliminate these variables : the submatrix built with their columns must be</span>
<a name="l00075"></a>00075 <span class="comment">* full-rank.  brute force method, that tests all the combinations until finding</span>
<a name="l00076"></a>00076 <span class="comment">* one which works.  </span>
<a name="l00077"></a>00077 <span class="comment">* &lt;b&gt;LIMITATIONS&lt;/b&gt; : up to x-1 variables, where the long long</span>
<a name="l00078"></a>00078 <span class="comment">* format is x-1 bits (often 64 in year 2005).  </span>
<a name="l00079"></a>00079 <span class="comment">*/</span>
<a name="l00080"></a>00080 <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> * <a class="code" href="matrix__permutations_8c.html#af43c186b57b2df6caa02a812c175a4d1" title="finds a valid permutation : for a set of m equations, find m variables that will...">find_a_permutation</a>(<a class="code" href="structmatrix.html">Matrix</a> * Eqs, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nb_parms);
<a name="l00081"></a>00081 
<a name="l00082"></a>00082 <span class="comment">/*</span>
<a name="l00083"></a>00083 <span class="comment">* compute the permutation of variables and parameters, according to some</span>
<a name="l00084"></a>00084 <span class="comment">* variables to keep.  put the variables not to be kept at the beginning, then</span>
<a name="l00085"></a>00085 <span class="comment">* the parameters and finally the variables to be kept.  strongly related to the</span>
<a name="l00086"></a>00086 <span class="comment">* function compress_to_full_dim2</span>
<a name="l00087"></a>00087 <span class="comment">*/</span>
<a name="l00088"></a>00088 <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> * <a class="code" href="matrix__permutations_8c.html#a2969569d57d59249e748e075e2494789" title="computes the permutation of variables and parameters, according to some variables...">permutation_for_full_dim2</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> * vars_to_keep, 
<a name="l00089"></a>00089                                          <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nb_keep, 
<a name="l00090"></a>00090                                          <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nb_vars_parms, 
<a name="l00091"></a>00091                                          <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nb_parms);
<a name="l00092"></a>00092 
<a name="l00093"></a>00093 <span class="preprocessor">#endif </span><span class="comment">/*__BM_MATRIX_PERMUTATIONS_H__ */</span>
</pre></div></div>
<hr size="1"/><address style="text-align: right;"><small>Generated on Wed Nov 25 17:45:26 2009 for polylib by&nbsp;
<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.6.1 </small></address>
</body>
</html>
